--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- Var ini
local t = 0;
local tLim = 0;
local tDelay = 1000;
local strange = 0;
local px = 0;
local py = 0;
local zone = "";
local subZone = "";
local zoneText = "";
local inInstance = false;
local instanceType = "";


-- TalkingHeadFrame

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsUpdateHandler = function()
	--toChat( GetMouseFocus():GetName() );
	--[[
	if (not GetMouseFocus():GetName()) then
	else
		print( GetMouseFocus():GetName() );
	end
	--]]

	-- DCoords ready?
	if ( DCoordsGVar["DCReady"] == false ) then
		return;
	end
	
	
	-- instance flags
	inInstance, instanceType = IsInInstance();
	
	
	
	-- Combat flag
	DCoordsGVar["IsInCombat"] = UnitAffectingCombat('player');
	if (not DCoordsGVar["IsInCombat"]) then
		DCoordsGVar["IsInCombat"] = false;
	end
	
	
	-- Handle update timing
	t = t+1;
	
	if (t <= tLim) then
		return;
	else
		t = 0;
		
		if (inInstance == true) then
			tDelay = DCoordsDBZ["updateDelayInDungeonOrRaid"];
		else
	
			if (DCoordsGVar["IsInCombat"] == false) then
				tDelay = DCoordsDBZ["updateDelay"];
			else
				tDelay = DCoordsDBZ["updateDelayInCombat"];
			end
			
		end
	end
	
	tLim = t + tDelay;
	
	--toChat("DC: tDelay = " .. tostring(tDelay) .. "   tlim = " .. tostring(tLim) );
	
	
	-- Get the players coordinates
	px, py = GetPlayerMapPosition("player");
	local coordsWereNull = false;
	if (px == nil) then
		px = 0;
		coordsWereNull = true;
	end
	if (py == nil) then
		py = 0;
	end
	px = px * 100;
	py = py * 100;
	--toChat(px .. ":" .. py);
	

	-- Minimap text
	if (MinimapZoneText:IsVisible() == true) then
		
		if (MinimapZoneText ~= nil) then
	
			if ( DCoordsDBZ["MinimapLocationBar"].coordinatesEnabled == true) then
				local miniMapCoordinates = DCoordsRoundTo(px,DCoordsDBZ["MinimapLocationBar"].decimalPrecision) .. " : " .. DCoordsRoundTo(py,DCoordsDBZ["MinimapLocationBar"].decimalPrecision);
				if (DCoordsDBZ["MinimapLocationBar"].displayZone == true) then
					if (coordsWereNull == true) then
						MinimapZoneText:SetText( DCoordsGVar["DCZone"] );
					else
						MinimapZoneText:SetText( DCoordsGVar["DCZone"] .. " - " .. miniMapCoordinates );
					end
				else
					if (coordsWereNull == true) then
						MinimapZoneText:SetText( DCoordsGVar["DCZone"] );
					else
						MinimapZoneText:SetText( miniMapCoordinates );
					end
				end	
			end
		
		end
		
	end
	
	
	-- Update MainBar
	if ( DCoordsDBZ["MainBar"].visible == true ) then
		updateMainBar();
	end
	
	-- Update WorldMap
	--if ( DCoordsDBZ["WorldMap"].visible == true and WorldMapFrame:IsVisible() == true ) then
	if ( WorldMapFrame:IsVisible() == true ) then
	
		if ( DCoordsGVar["IsInCombat"] == false ) then
			updateWorldMap();
		end
		
	end
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #












-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateMainBar()
		
	-- Prevent update if MainBar is not visible
	if ( DCoordsGVar["DCMainBar"]:IsVisible() == false) then
		return;
	end

	if (DCoordsDBZ["MainBar"].showZone == true) then
		zone = DCoordsGVar["DCZone"];
	else
		zone = "";
	end
	
	if (DCoordsDBZ["MainBar"].showSubZone == true) then
		subZone = DCoordsGVar["DCSubZone"];
	else
		subZone = "";
	end
	
	
	
	local mainBarCoordinates = DCoordsRoundTo(px,DCoordsDBZ["MainBar"].decimalPrecision) .. " : " .. DCoordsRoundTo(py,DCoordsDBZ["MainBar"].decimalPrecision);
	
	
	
	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		if (zone ~= "") and (subZone ~= "") then
			location = zone .. " - " .. subZone;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone;
		elseif (zone ~= "") and (subZone == "") then
			location = zone;
		else
			location = DCoordsTempText;
		end
	else
		if (zone == "") and (subZone == "") then
			location = mainBarCoordinates;
		elseif (zone ~= "") and (subZone == "") then
			location = zone .. " - " .. mainBarCoordinates;
		elseif (zone == "") and (subZone ~= "") then
			location = subZone .. " - " .. mainBarCoordinates;
		elseif (zone ~= "") and (subZone ~= "") then
			if (zone == subZone) then
				location = zone .. " - " .. mainBarCoordinates;
			else
				location = zone .. " - " .. subZone .. " - " .. mainBarCoordinates;
			end
		else
			location = "      ";
		end
	end
	
	location = "  " .. location .. "  ";
	
	--DCoordsGVar["DCMainBarText"]:SetText(" " .. t .. " " .. location);
	DCoordsGVar["DCMainBarText"]:SetText(location);
	--DCoordsGVar["DCMainBarText"]:SetJustifyH("LEFT");
	
	
	if (DCoordsGVar["DCMainBar"]:IsVisible() == true) then
		
		local frameW = DCoordsGVar["DCMainBarText"]:GetStringWidth() + DCoordsDBZ["MainBar"].paddingLeftRight;
		local frameH = DCoordsGVar["DCMainBarText"]:GetStringHeight() + DCoordsDBZ["MainBar"].paddingTopBottom;
		
		if (oldW ~= frameW) then
			oldW = frameW;
			DCoordsGVar["DCMainBar"]:SetWidth(frameW);
			DCoordsGVar["DCMainBar"]:SetHeight(frameH);
			local dcW = tostring(DCoordsRoundTo(frameW,2));
			local dcH = tostring(DCoordsRoundTo(frameH,2));
			--toChat("FRAME UPDATE:" .. dcW .. ":" .. dcH);
		end
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

local oldW = 0;
local oldH = 0;




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateWorldMap()

	if ( WorldMapFrame:IsVisible() == false ) then
		return;
	end

	--DCoordsGVar["DCWorldMapText"]:SetText(" " .. t .. " " .. location);
	
	-- World map calc
	local mapscale = WorldMapDetailFrame:GetEffectiveScale();
	local cursorX, cursorY = GetCursorPosition();
	cursorX = cursorX / mapscale;
	cursorY = cursorY / mapscale;
	local width = WorldMapDetailFrame:GetWidth();
	local height = WorldMapDetailFrame:GetHeight();
	local left = WorldMapDetailFrame:GetLeft();
	local top = WorldMapDetailFrame:GetTop();
	
	cursorX = (cursorX - left) / width * 100;
	cursorY = (top - cursorY) / height * 100;
	
	local cx, cy;
	if (DCoordsDBZ["WorldMap"].decimalPrecision==3) then
		cx = format("%.3f",cursorX);
		cy = format("%.3f",cursorY);
	elseif (DCoordsDBZ["WorldMap"].decimalPrecision==2) then
		cx = format("%.2f",cursorX);
		cy = format("%.2f",cursorY);
	elseif (DCoordsDBZ["WorldMap"].decimalPrecision==1) then
		cx = format("%.1f",cursorX);
		cy = format("%.1f",cursorY);
	else
		cx = floor(cursorX);
		cy = floor(cursorY);
	end


	local worldMapCoordinates = DCoordsRoundTo(px,DCoordsDBZ["WorldMap"].decimalPrecision) .. " : " .. DCoordsRoundTo(py,DCoordsDBZ["WorldMap"].decimalPrecision);

	
	--DCoordsGVar["DCWorldMapText"]:SetText("You: [" .. playerX .. " - " .. playerY .. "]     " .. DCoordsMapTextLabel);
	if (tonumber(px) < 0.01 and tonumber(py) < 0.01) then
		DCoordsGVar["DCWorldMapText"]:SetText("Cursor " .. cx .. " : " .. cy);
	else 
		DCoordsGVar["DCWorldMapText"]:SetText("You " .. worldMapCoordinates .. "     Cursor " .. cx .. " : " .. cy);
		--log(DCoordsMapTextLabel);
		--log(mouseIsOverMap);
		--log( GetMouseFocus():GetName() );
	end	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
