--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageWelcome()
	DCoordsGVar["DCOptions"].Main = CreateFrame( "Frame", "DCoordsOptionsMainPage", UIParent );
	local frame = DCoordsGVar["DCOptions"].Main;
	frame.name = "DCoords";
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"");
	
    -- Page of settings
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 200;
	local sliderWidth = 200;
	local msg = "";
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "Thanks for using DCoords v" .. tostring(DCoordsVersion) .. "!" .. "\n\n";
	msg = msg .. "A thank you to those whom use the addon and let me know about bugs!" .. "\n";
	msg = msg .. "NOTE: When reporting bugs, let me know your basic settings and a description of the error." .. "\n\n\n";
	
	msg = msg .. "Wish to make a donation?\nPlease visit paypal.me/DarceyLloyd  (!BIG THANKS TO THOSE WHO DO!)" .. "\n\n\n";
	
	msg = msg .. "What's new?" .. "\n";
	msg = msg .. "Updated version so that its no longer flagged as out of date for wow v7.2." .. "\n\n";
	msg = msg .. "\n\n";
	msg = msg .. "USAGE GUIDE:" .. "\n\n";
	msg = msg .. "- To view options type /DC menu or right click on coordinates bar.";
	msg = msg .. "\n\n";
	msg = msg .. "- You can drag the coordinates bar by holding SHIFT, LEFT CLICK AND DRAG.";
	msg = msg .. "\n\n";
	msg = msg .. "- Objectives tracker features if enabled you can drag the objectives tracker by" .. "\n";
	msg = msg .. "holding SHIFT + LEFT CLICK Title and DRAG.";
	msg = msg .. "\n\n";
	msg = msg .. "- Setting alignment of coordinates bar will change the way the bar grows and shrinks in width." .. "\n";
	msg = msg .. "If you align left (Top left, Left, Bottom left), the coordinates bar will expand to the right." .. "\n";
	msg = msg .. "If you align right (Top right, Right, Bottom right), the coordinates bar will expand to the left." .. "\n";
	msg = msg .. "If you align center (Top, Center, Bottom), the bar will expand both ways (DCoords v3 behaviour).";
	msg = msg .. "\n\n\n";
	msg = msg .. "- HAVING PROBLEMS?\nRESET by either typing /DC reset or go to options > other and click on reset.\nStill stuck? Message me via curse.com and I will try to help.";
	msg = msg .. "\n\n"; 
	local mainInfo1 = createLabel("mainInfo1",frame,msg,DCoordsMenuFontSize,1,1,1,1,"LEFT",px,py);
	py = py - 25;
	
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
