--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
initWorldMapCoordinates = function()
	log("initWorldMapCoordinates()");
	
	DCoordsGVar["DCWorldMapText"] = WorldMapButton:CreateFontString();
	
    worldMapSetFont();
	worldMapSetPosition();
    worldMapSetVisibility();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function worldMapSetVisibility()
    --log("worldMapSetVisibility()");

    if (DCoordsDBZ["WorldMap"].visible) then
		DCoordsGVar["DCWorldMapText"]:Show();
	else
		DCoordsGVar["DCWorldMapText"]:Hide();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function worldMapSetPosition()
    --log("worldMapSetPosition()");
    
	local textAlignment = DCoordsGVar["WorldMapAlignmentOptions"][ DCoordsDBZ["WorldMap"].fontAlignmentIndex ];
	--log("textAlignment = " .. textAlignment);
	
	DCoordsGVar["DCWorldMapText"]:ClearAllPoints();
	DCoordsGVar["DCWorldMapText"]:SetPoint("TOP", WorldMapButton, textAlignment, 0, DCoordsDBZ["WorldMap"].fontOffsetY);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function worldMapSetFont()
    --log("worldMapSetFont()");
    
    DCoordsGVar["DCWorldMapText"]:SetTextColor(
        DCoordsDBZ["WorldMap"].fontR,
        DCoordsDBZ["WorldMap"].fontG,
        DCoordsDBZ["WorldMap"].fontB,
        DCoordsDBZ["WorldMap"].fontA
    );
    
    DCoordsGVar["DCWorldMapText"]:SetFont(getMapFrameFont(), DCoordsDBZ["WorldMap"].fontSize,"OUTLINE");
    
    local textAlignment = DCoordsGVar["AlignmentOptions"][ DCoordsDBZ["WorldMap"].fontAlignmentIndex ];
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









